#ifndef LIST_HH__
#define LIST_HH__

template<class T>
class List {
	struct Elem {
		T data_;
		Elem* prev_;
		Elem* next_;

		Elem(T val)
		: data_(val),
		  prev_(0),
		  next_(0)
		{}
	};

	Elem* head_;
	Elem* tail_;

public:
	List() 
	: head_(0),
	  tail_(0)
	{}

	void push_back(T val) {
		Elem* newElem=new Elem(val);
		if(head_==0) {
			head_=tail_=newElem;
		} else {
			tail_->next_=newElem;
			newElem->prev_=tail_;
			tail_=newElem;
		}
	}

	void pop_back() {
		if(head_==0){
			return;
		} else if(head_==tail_) {
			delete head_;
			head_=tail_=0;
		} else {
			Elem* t=tail_;
			tail_=tail_->prev_;
			tail_->next_=0;

			delete t;
		}
	}
	
	T back() {
		return tail_->data_;
	}
	
	bool empty() const {
		return head_==0;
	}
	
	~List() {
		while(!empty()) {
			pop_back();
		}
	}

	void push_front(T val) {
		Elem* newElem=new Elem(val);
		if(head_==0) {
			head_=tail_=newElem;
		} else {
			tail_->next_=newElem;
			newElem->prev_=tail_;
			tail_=newElem;
		}
	
	}

};


#endif
